/******************************************************************************/
/*                                                                            */
/*                      sum up all partitional results                        */
/*                                                                            */
/******************************************************************************/

#include <iostream>
#include <fstream>

using namespace std;

int main ()
{
//  int i;
  int counter[4];
  counter[0] = 0;	                                            //equalities
  counter[1] = 0;	                                               //subsets
  counter[2] = 0;	                                             //supersets
  counter[3] = 0;	                                       //other relations

  int dummy;

  cout << endl;
  cout << endl;
  cout << endl;
  cout << "***********************************************************" << endl;
  cout << "*                      FINAL RESULT                       *" << endl;
  cout << "***********************************************************" << endl;

  ifstream sum("./test/ergebnis.dat");
  if (!sum)
  {
    cout << "Error trying to read ergebnis.dat" << endl;
    return 1;
  }

  while (!sum.eof())
  {
    sum >> dummy;
    counter[0] = counter[0] + dummy;
    sum >> dummy;
    counter[1] = counter[1] + dummy;
    sum >> dummy;
    counter[2] = counter[2] + dummy;
    sum >> dummy;
    counter[3] = counter[3] + dummy;
  }

  sum.close();

  counter[0] = counter[0] - dummy;
  counter[1] = counter[1] - dummy;
  counter[2] = counter[2] - dummy;
  counter[3] = counter[3] - dummy;

  cout << endl;
  cout << "Number of equalities :" << counter[0] << endl;
  cout << "Number of subsets    :" << counter[1] << endl;
  cout << "Number of supersets  :" << counter[2] << endl;
  cout << "Other relations      :" << counter[3] << endl;

  if (counter[0] == 159)                  //159 = Number of intervals to compare
  {
    cout << endl;
    cout << "*********************************************************" << endl;
    cout << "*    All results are equal to the expected solutions.   *" << endl;
    cout << "*  It seems the libraries (C-XSC and CToolbox) are OK!  *" << endl;
    cout << "*********************************************************" << endl;
  }
  else if ((counter[0]+counter[2]) == 159) 
  {
    cout << endl;
    cout << "*********************************************************" << endl;
    cout << "*    All results are equal to or supersets of the       *" << endl;
    cout << "*                  expected solutions.                  *" << endl;
    cout << "*  It seems the libraries (C-XSC and CToolbox) are OK!  *" << endl;
    cout << "*********************************************************" << endl;
  }
  else
  {
     cout << endl;
     cout << "********************************************************" << endl;
     cout << "*     Warning: There are some unexpected solutions!    *" << endl;
     cout << "* It seems one library (C-XSC or CToolbox) in not OK!  *" << endl;
     cout << "********************************************************" << endl;
  }
  
  return 0;
}
